'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _htmlTags = require('html-tags');

var _htmlTags2 = _interopRequireDefault(_htmlTags);

var _rule = require('rockey/rule');

var _rule2 = _interopRequireDefault(_rule);

var _when = require('rockey/when');

var _when2 = _interopRequireDefault(_when);

var _insert = require('rockey/insert');

var _insert2 = _interopRequireDefault(_insert);

var _condition = require('rockey/condition');

var _condition2 = _interopRequireDefault(_condition);

var _ = require('./');

var _2 = _interopRequireDefault(_);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var look = function look(BaseComponent) {
  return function () {
    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    var css = (0, _rule2.default)(args);

    return css.transform(function (tree, create) {
      var components = Object.keys(tree.components);
      var size = components.length;

      if (!size) {
        throw new Error('Rockey look should containt at least one root component');
      }

      var parentDisplayName = components[0];
      var parentCss = create({
        components: _defineProperty({}, parentDisplayName, tree.components[parentDisplayName])
      });

      var children = {};

      for (var i = 1; i < size; i++) {
        var displayName = components[i];

        var comopnentCss = create({
          components: _defineProperty({}, displayName, tree.components[displayName])
        });
        comopnentCss.addParent(parentCss);

        children[displayName] = (0, _2.default)(BaseComponent, {
          displayName: displayName,
          parentCss: comopnentCss
        });
      }

      return Object.assign({}, children, _defineProperty({}, parentDisplayName, (0, _2.default)(BaseComponent, {
        displayName: parentDisplayName,
        parentCss: parentCss
      })));
    });
  };
};

look.when = _when2.default;
look.condition = _condition2.default;
look.insert = _insert2.default;

var _loop = function _loop(tag) {
  // ---- tag hoc lazy creation
  Object.defineProperty(look, tag, {
    get: function get() {
      return function () {
        return look(tag).apply(undefined, arguments);
      };
    }
  });
};

var _iteratorNormalCompletion = true;
var _didIteratorError = false;
var _iteratorError = undefined;

try {
  for (var _iterator = _htmlTags2.default[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
    var tag = _step.value;

    _loop(tag);
  }
} catch (err) {
  _didIteratorError = true;
  _iteratorError = err;
} finally {
  try {
    if (!_iteratorNormalCompletion && _iterator.return) {
      _iterator.return();
    }
  } finally {
    if (_didIteratorError) {
      throw _iteratorError;
    }
  }
}

exports.default = look;